// Huffman.cpp : Defines the entry point for the console application.
//

//#include "stdafx.h"
#include <iostream>
#include <io>
#include <stdlib>
#include <dir>
#include <stdio>
#include <conio>

/*
using std::cout;
using std::cin;
using std::endl;
*/
/*Global variable declarations ***/
struct node
{
	unsigned char c;
	unsigned long int freq;
	struct node *up,*left,*right;
};
struct ftable
{
	unsigned long int freq;
};
struct ftable ft;
struct node leaf[256];
struct node *t[256];
struct node *a,*b;
int i,j,k;
int buf[50],bc;
int buft[20],bct;
int buftv[20];
unsigned char q;
long int y=0;/*For debugging in Decompressing*/

//All Function Prototype
int getzero();
int maketree();



//Encode Function prototype
int nodecmp(struct node *,struct node *);
int nodecpy(struct node *,struct node *);
//Encode Function Body
int initEncode(char *filename)
{
	FILE *p;
	for(i=0;i<256;i++)
	{
		leaf[i].c=i;
		leaf[i].freq=0;
		leaf[i].up=NULL;
		leaf[i].left=NULL;
		leaf[i].right=NULL;
	}
	p=fopen(filename,"rb");
	if(p==NULL)
	{
		return -1; /*Could not open file */
	}
	while(j=fgetc(p),j!=EOF)
	{
		leaf[j].freq++;
		if(j<0 || j>255)
					cout<<"\nError...";
 	}
	fclose(p);
	for(i=0;i<256;i++)
	{
		t[i]=&leaf[i];
		if((t[i]->up)!=NULL)
			cout<<"\nError..";
   }
	bc=0;  /*Setting the global buffer counter to 0*/
	return 0;
}

void add2buffEncode(int r)
{
	bct=-1;
	if(r>255 || r<0)
			cout<<"\nValue error...";
   a=&leaf[r];
	while((a->up)!=NULL)
	{
		if(nodecmp((a->up->left),a)==0)
		{
			buft[++bct]=0;
		}
		else if(nodecmp((a->up->right),a)==0)
		{
			buft[++bct]=1;
		}
		else
			cout<<"\nParent Error";  /*For debugging*/
		a=a->up;
	}
	for(i=0;i<=bct;i++)
		buftv[bct-i]=buft[i];
	for(i=0;i<=bct;i++)
			buf[bc+i]=buftv[i];
	bc=bc+bct+1;
	return;  /*Successful completetion of function*/
}


void refreshbufferEncode(FILE *p)
{
	while(bc>=8)
	{
		q=(1*buf[7])+(2*buf[6])+(4*buf[5])+(8*buf[4])+(16*buf[3])+(32*buf[2])+(64*buf[1])+(128*buf[0]);
		if(fputc(q,p)!=(unsigned)q || q<0 || q>255)cout<<"\nError";
		for(i=8;i<bc;i++)
				buf[i-8]=buf[i];
		bc-=8;
	}
}

int nodecmp(struct node *a,struct node *b)
{
	if(a->c==b->c && a->freq==b->freq && a->up==b->up &&a->left==b->left && a->right==b->right)
		return 0;
	return -1;
}

int nodecpy(struct node *a,struct node *b)
{
	a->c=b->c;
	a->freq=b->freq;
	a->up=b->up;
	a->left=b->left;
	a->right=b->right;
	return 0;
}

char *getname(char *filepath)
{
	char drive[4],dir[67],file[15],ext[5];
	fnsplit(filepath,drive,dir,file,ext);
	//filepath=file;
	strcat(file,ext);
	return file;
}

unsigned char oddchar()
{
	for(i=bc;i<8;i++)
	{
		buf[i]=0;
	}
	return ((1*buf[7])+(2*buf[6])+(4*buf[5])+(8*buf[4])+(16*buf[3])+(32*buf[2])+(64*buf[1])+(128*buf[0]));
}

int EncMain()
{
	FILE *p,*q;
	int ch;
	char filename[100],encfile[100];
	long int filesize,encfilesize;
	float ratio;
	//clrscr();
	cout<<"\nData compression by the Huffman algorithm";
	cout<<"\nEnter the name of the input file(to be compressed):";
	scanf("%s",filename);
	cout<<"\nEnter the output filename(compressed file):";
	scanf("%s",encfile);
	if(initEncode(filename)==-1)
	{
		cout<<"\nError Could not open input file..";
		fcloseall();
		return -1;
	}
	cout<<"\nInitialization over.\nPreparing to compress...";
	if(maketree()==-1)
	{
		cout<<"\nMemory allocation error..";
		fcloseall();
		return -1;
	}
	q=fopen(encfile,"wb");
	if(q==NULL)
	{
		cout<<"\nError Could not open output file..";
		fcloseall();
		return -1;
	}
	p=fopen(filename,"rb");
	if(p==NULL)
	{
		cout<<"\nError Could not open input file...";
		fcloseall();
		return -1;
	}
	filesize=filelength(fileno(p));
	/****To write the decoding table */
	for(i=0;i<256;i++)
	{
		ft.freq=leaf[i].freq;
		fwrite(&ft.freq,sizeof(struct ftable),1,q);
	}
	/*To write the character that denotes the size of filenamelength*/
	fputc(strlen(getname(filename))+1,q);
	/*To write the filename*/
	fwrite(getname(filename),strlen(getname(filename))+1,1,q);
	/***Completed writing of decoding table*****/
	cout<<"\nCompressing...";
	while(ch=fgetc(p),ch!=EOF)
	{
		add2buffEncode(ch);
		refreshbufferEncode(q);
	}
	fputc(oddchar(),q);
	fputc(bc,q);
	fcloseall();
	cout<<"\nCompression complete.";
	/*****For display of compression summary****/
	p=fopen(encfile,"rb");
	if(p==NULL)
	{
		cout<<"\nCould not open output file for analysis";
		cout<<"\nCompression summary cannot be displayed";
		return -1;
	}
	encfilesize=filelength(fileno(p));fcloseall();
	cout<<"\n\nCompression summary\n";
	cout<<"\nInput filesize :"<<filesize<<" bytes";
	cout<<"\nOutput filesize: "<<encfilesize;
	ratio=(float)(encfilesize*100/filesize);
	cout<<"\nCompressed to "<<ratio<<"  of original size";
	return 0;
}

//Decode  Function Budy
void add2buffDecode(int c)
{
	bct=-1;
	while(c!=0)
	{
		buft[++bct]=(c%2);
		c/=2;
	}
	for(i=(bct+1);i<8;i++)
			buft[i]=0;
	for(i=(0);i<8;i++)
			buftv[7-i]=buft[i];
   for(i=0;i<8;i++)
		buf[bc+i]=buftv[i];
	bc+=8;
}

void refreshbufferDecode(FILE *p)
{
	int count=0,j,i;
	//int bcbak=bc;
	a=t[0];i=0;
	for(i=0;i<=bc;i++)
	{
		if(a->left==NULL && a->right==NULL)
		{
			fputc(a->c,p);
			/*For debugging*/
			y++;
			/*debugging over*/
			for(j=count;j<bc;j++)
					buf[j-count]=buf[j];
			bc-=count;
			//i=0;
			count=0;
			a=t[0];
		}
		else if(buf[count]==0)
		{
			a=a->left;
			count++;
			//i++;
		}
		else if(buf[count]==1)
		{
			a=a->right;
			count++;
			//i++;
		}
		else
		   cout<<"\nError";

	}
	return;
}



void initDecode()
{
	int i;
	for(i=0;i<256;i++)
	{
		leaf[i].c=(unsigned char)i;
		leaf[i].freq=0;
		leaf[i].up=NULL;
		leaf[i].left=NULL;
		leaf[i].right=NULL;
		t[i]=&leaf[i];
	}
	for(i=0;i<256;i++)
	{
		t[i]=&leaf[i];
	}
	return;
}

int retrieveft(char *filename)
{
	FILE *p;
	p=fopen(filename,"rb");
	if(p==NULL)
	{
		return -1;/*Could not open file */
	}
	for(i=0;i<256;i++)
	{
		fread(&ft,sizeof(struct ftable),1,p);
		leaf[i].c=(unsigned char)i;
		leaf[i].freq=ft.freq;
		leaf[i].up=NULL;
		leaf[i].right=NULL;
		leaf[i].left=NULL;
	}
	fclose(p);
	return 0;
}

int DecMain()
{
	char filename[100],outfile[100];
	FILE *p,*q;
	int ch,ct;
	long int filelen,count=1024;
	clrscr();
	cout<<"\nFile decompressor for files compressed with HuffEnc";
	cout<<"\nEnter the filename:";scanf("%s",filename);
	initDecode();
	if(retrieveft(filename)==-1)
	{
		printf("\nCould not open file");
		return -1;
	}
	maketree();
	/*To retrieve the filename from the compressed file*/
	p=fopen(filename,"rb");
	fseek(p,1024,SEEK_SET);
	ct=fgetc(p);
	fread(outfile,ct,1,p);
	/***Filename retrieval finished*/
	p=fopen(filename,"rb");
	/***check for user renaming of output file*/
	cout<<"\nThe specified archive contains a compressed file called "<<outfile;
	cout<<"\nYou may choose to create this file or specify a name for the file to be created";
	cout<<"\nSpecify a name for the output file(y/any other key):";
	if((getch())=='y')
	{
		cout<<"\n\nEnter name for file to be created:";scanf("%s",outfile);
	}
	/******check for renaming complete*****/
	q=fopen(outfile,"wb");
	if(q==NULL || p==NULL)
	{
		printf("\nCould not open one or more files");
		fcloseall();
		return -1;
	}
	fseek(p,256*sizeof(struct ftable)+1+ct,SEEK_SET);
	filelen=filelength(fileno(p));
	count=1024+1+ct;
	cout<<"\n\nInitialization over.\nPreparing to decompress..";
	cout<<"\nDecompressing....";
	while(ch=fgetc(p),count++,ch!=EOF)
	{
		if(count==(filelen-1))
		{
			add2buffDecode(ch);
			bc-=8;
			bc+=fgetc(p);
			refreshbufferDecode(q);
			while(bc!=0)
			{
				refreshbufferDecode(q);
			}
		}
		else
		{
			add2buffDecode(ch);
			refreshbufferDecode(q);
		}
	}
	cout<<"\nDecompression complete.\n";
	cout<<"\nCreated output file "<<outfile;
	return 0;
}








//Encode And Decode
int sortt(int z)/*sorts upto t[z] and not t[z-1]*/
{
	for(k=0;k<=z;k++)
	for(j=(k+1);j<=z;j++)
	{
		if((t[k]->freq)<(t[j]->freq))
		{
			//b=NULL;
			b=t[k];
			t[k]=t[j];
			t[j]=b;
		}
	}
	return 0;
}

int maketree()
{
	struct node *a;
	sortt(255);
	for(i=getzero();i>0;i--)
	{
		sortt(i);
		a=NULL;
		a=(struct node *)malloc(sizeof(struct node));
		if(a==NULL)
		{
			cout<<"\nMemory allocation error...";
			return -1;  /*Memory allocation error*/
		}
		/*Assingning values*/
		a->freq=(t[i]->freq)+(t[i-1]->freq);
		a->right=t[i];
		a->left=t[i-1];
		a->up=NULL;
		a->c='\0';
		t[i]->up=a;
		t[i-1]->up=a;
		/*Changing the pointer*/
		t[i-1]=a;
	}
	return 0;
}

int getzero()
{
	int h=0;
	for(i=0;i<256;i++)
	{
		if(leaf[i].freq==0)
			h++;
	}
	return (255-h);
}





int _tmain(int argc, _TCHAR* argv[])
{
   int choice;
   cout<<"Enter (1) For Encode\n";
   cout<<"Enter (2) For Decode\n";
   cin>>choice;
   switch(choice)
   {
	case 1:EncMain();break;
   case 2:DecMain();break;
   default:cout<<"Illegal";break;
   }
	return 0;
}

